package org.apache.commons.lang3;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.function.BiConsumer;
import java.util.function.BinaryOperator;
import java.util.function.Supplier;
import java.util.stream.Collector;
import java.util.stream.Stream;
import org.apache.commons.lang3.Functions;
import org.apache.commons.lang3.Streams;

@Deprecated
public class FailableStream<O> {
  private Stream<O> stream;
  
  private boolean terminated;
  
  public FailableStream(Stream<O> stream) {
    this.stream = stream;
  }
  
  protected void assertNotTerminated() {
    if (this.terminated)
      throw new IllegalStateException("This stream is already terminated."); 
  }
  
  protected void makeTerminated() {
    assertNotTerminated();
    this.terminated = true;
  }
  
  public FailableStream<O> filter(Functions.FailablePredicate<O, ?> predicate) {
    assertNotTerminated();
    this.stream = this.stream.filter(Functions.asPredicate(predicate));
    return this;
  }
  
  public void forEach(Functions.FailableConsumer<O, ?> action) {
    makeTerminated();
    stream().forEach(Functions.asConsumer(action));
  }
  
  public <A, R> R collect(Collector<? super O, A, R> collector) {
    makeTerminated();
    return stream().collect(collector);
  }
  
  public <A, R> R collect(Supplier<R> pupplier, BiConsumer<R, ? super O> accumulator, BiConsumer<R, R> combiner) {
    makeTerminated();
    return stream().collect(pupplier, accumulator, combiner);
  }
  
  public O reduce(O identity, BinaryOperator<O> accumulator) {
    makeTerminated();
    return stream().reduce(identity, accumulator);
  }
  
  public <R> FailableStream<R> map(Functions.FailableFunction<O, R, ?> mapper) {
    assertNotTerminated();
    return new FailableStream(this.stream.map(Functions.asFunction(mapper)));
  }
  
  public Stream<O> stream() {
    return this.stream;
  }
  
  public boolean allMatch(Functions.FailablePredicate<O, ?> predicate) {
    assertNotTerminated();
    return stream().allMatch(Functions.asPredicate(predicate));
  }
  
  public boolean anyMatch(Functions.FailablePredicate<O, ?> predicate) {
    assertNotTerminated();
    return stream().anyMatch(Functions.asPredicate(predicate));
  }
}
